#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

#define int long long
using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

void solve1();

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int qwerty = 1;
    // cin >> qwerty;
    while (qwerty--) {
        solve1();
    }
}

const int INF = 1e18;

struct seg_tree {
    struct Node {
        int sum, mndept;
    };

    vector<Node> d;
    vector<int> a;

    seg_tree(int n, vector<int> &b) {
        d.resize(4 * n);
        a = b;
        build(0, 0, n);
    }

    void build(int v, int l, int r) {
        if (r - l == 1) {
            d[v].sum = a[l];
            return;
        }
        int mid = (l + r) / 2;
        build(v * 2 + 1, l, mid);
        build(v * 2 + 2, mid, r);
        d[v].sum = d[2 * v + 1].sum + d[2 * v + 2].sum;
    }

    int query(int v, int l, int r, int ql, int qr) {
        if (ql >= r || l >= qr) return 0;
        if (ql <= l && r <= qr) return d[v].sum;
        int mid = (l + r) / 2;
        return query(2 * v + 1, l, mid, ql, qr) + query(2 * v + 2, mid, r, ql, qr);
    }

    void update(int v, int l, int r, int ind, int val) {
        if (r - l == 1) {
            d[v].sum = min(d[v].sum, a[l]);
            return;
        }
        int mid = (l + r) / 2;
        if (ind < mid) {
            update(v * 2 + 1, l, mid, ind, val);
        } else {
            update(v * 2 + 2, mid, r, ind, val);
        }
        d[v].sum = d[2 * v + 1].sum + d[2 * v + 2].sum;
    }
};

void solve1() {
    int n;
    cin >> n;
    vector<int> h(n);
    for (int i = 0; i < n; i++) {
        cin >> h[i];
    }
    vector<int> pref(n);
    pref[0] = h[0];
    for (int i = 1; i < n; i++) {
        pref[i] = pref[i - 1] + h[i];
    }
    vector<pair<int, int> > cnt(n);
    vector<int> mxl(n);
    vector<int> l(n), r(n);
    for (int i = 0; i < n; i++) {
        l[i] = i;
        r[i] = i;
        cnt[i] = {i, i};
        mxl[i] = h[i];
    }
    vector<int> lb(n, -1), rb(n, n);
    stack<pair<int, int> > st;
    st.push({h[0], 0});
    for (int i = 1; i < n; i++) {
        while (!st.empty() && st.top().first <= h[i]) {
            st.pop();
        }
        if (!st.empty()) {
            lb[i] = st.top().second;
        }
        st.push({h[i], i});
    }
    st = {};
    st.push({h[n - 1], n - 1});
    for (int i = n - 2; i >= 0; i--) {
        while (!st.empty() && st.top().first <= h[i]) {
            st.pop();
        }
        if (!st.empty()) {
            rb[i] = st.top().second;
        }
        st.push({h[i], i});
    }
    seg_tree tree(n, h);
    for (int qq = 0; qq < n - 1; qq++) {
        int k;
        cin >> k;
        k--;
        int sz1 = cnt[k].second - cnt[k].first + 1;
        int sz2 = cnt[k + 1].second - cnt[k + 1].first + 1;
        int l1 = cnt[k].first;
        int l2 = cnt[k + 1].first;
        int r1 = cnt[k].second;
        int r2 = cnt[k + 1].second;
        for (int i = r2; i >= l1; i--) {
            for (int j = i; j >= min(l1, lb[i]); j--) {
                tree.update(0, 0, n, j, h[i]);
            }
            tree.update(0, 0, n, i, max(mxl[k], l[i]));
            l[i] = max(l[i], mxl[k]);
        }
        mxl[k] = max(mxl[k], mxl[k + 1]);
        int ans = tree.query(0, 0, n, l1, r2 + 1) - pref[r2];
        ans += l1 != 0 ? pref[l1 - 1] : 0;
        cout << ans << '\n';
        cnt[k] = {l1, r2};
        for (int i = k + 1; i < n - 1; i++) {
            swap(cnt[i], cnt[i + 1]);
            swap(mxl[i], mxl[i + 1]);
        }
    }
}
