#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

#define int long long
using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

void solve1();

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int qwerty = 1;
    // cin >> qwerty;
    while (qwerty--) {
        solve1();
    }
}

set<pair<int, int> > lr;
vector<int> l, r;
vector<int> h;

struct seg_tree {
    struct Node {
        int sum, mod;
    };

    vector<Node> d;
    vector<int> a;

    void build(int v, int l, int r, vector<int> &a) {
        if (r - l == 1) {
            d[v].sum = a[l];
            d[v].mod = -1;
            return;
        }
        int mid = (l + r) / 2;
        build(v * 2 + 1, l, mid, a);
        build(v * 2 + 2, mid, r, a);
        d[v].sum = d[2 * v + 1].sum + d[2 * v + 2].sum;
    }

    void push(int v, int l, int r) {
        if (r - l == 1) {
            if (d[v].mod != -1) {
                d[v].sum = d[v].mod;
            }
            return;
        }
        d[v].sum = (r - l) * d[v].mod;
        d[2 * v + 1].mod = d[v].mod;
        d[2 * v + 2].mod = d[v].mod;
        d[v].mod = -1;
    }

    int get(int v, int l, int r, int ql, int qr) {
        push(v, l, r);
        if (ql >= r || l >= qr) return 0;
        if (ql <= l && r <= qr) return d[v].sum;
        int mid = (l + r) / 2;
        return get(2 * v + 1, l, mid, ql, qr) + get(2 * v + 2, mid, r, ql, qr);
    }

    void update(int v, int l, int r, int ql, int qr, int val) {
        if (l >= qr || ql >= r) return;
        if (ql <= l && r <= qr) {
            push(v, l, r);
            d[v].sum = (r - l) * val;
            d[v].mod = val;
            return;
        }
        push(v, l, r);
        int mid = (l + r) / 2;
        update(v * 2 + 1, l, mid, ql, qr, val);
        update(v * 2 + 2, mid, r, ql, qr, val);
        d[v].sum = d[2 * v + 1].sum + d[2 * v + 2].sum;
    }
};

vector<int> lb, rb;

struct seg_tree_mx {
    vector<pair<int, int> > d;

    void build(int v, int l, int r, vector<int> &a) {
        if (r - l == 1) {
            d[v] = {a[l], l};
            return;
        }
        int mid = (l + r) / 2;
        build(v * 2 + 1, l, mid, a);
        build(v * 2 + 2, mid, r, a);
        d[v] = max(d[2 * v + 1], d[2 * v + 2]);
    }

    pair<int, int> get(int v, int l, int r, int ql, int qr) {
        if (l >= qr || ql >= r) return {-1, -1};
        if (ql <= l && r <= qr) return d[v];
        int mid = (l + r) / 2;
        return max(get(2 * v + 1, l, mid, ql, qr), get(2 * v + 2, mid, r, ql, qr));
    }
};

seg_tree_mx stmx;
seg_tree d;
int n;
map<pair<int, int>, int> old;

void update(int k) {
    int qqq = 0;
    int l1, r1, l2, r2;
    for (auto it = lr.begin(); it != lr.end(); it++) {
        if (qqq == k) {
            l1 = (*it).first;
            r1 = (*it).second;
            it++;
            l2 = (*it).first;
            r2 = (*it).second;
            break;
        }
        qqq++;
    }
    lr.erase({l1, r1});
    lr.erase({l2, r2});
    auto fir = stmx.get(0, 0, n, l1, r1);
    auto sec = stmx.get(0, 0, n, l2, r2);
    int ans = old[{l1, r1}] + old[{l2, r2}];
    int ll = max(l1, lb[sec.second] + 1);
    int rr = min(l2, rb[fir.second] - 1);
    ans -= d.get(0, 0, n, ll, r1 + 1);
    ans -= d.get(0, 0, n, l2, rr);
    d.update(0, 0, n, ll, r1 + 1, sec.second);
    d.update(0, 0, n, l2, rr, fir.second);
    ans -= d.get(0, 0, n, ll, r1 + 1);
    ans -= d.get(0, 0, n, l2, rr);
    cout << ans << '\n';
    old[{l1, r2}] = ans;
    lr.insert({l1, r2});
}

void solve1() {
    int n;
    cin >> n;
    h.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> h[i];
    }
    lb.resize(n, -1);
    rb.resize(n, n);
    stack<pair<int, int> > st;
    st.push({h[0], 0});
    for (int i = 1; i < n; i++) {
        while (!st.empty() && st.top().first <= h[i]) {
            st.pop();
        }
        if (!st.empty()) {
            lb[i] = st.top().second;
        }
        st.push({h[i], i});
    }
    st = {};
    st.push({h[n - 1], n - 1});
    for (int i = n - 2; i >= 0; i--) {
        while (!st.empty() && st.top().first <= h[i]) {
            st.pop();
        }
        if (!st.empty()) {
            rb[i] = st.top().second;
        }
        st.push({h[i], i});
    }
    l.resize(n);
    r.resize(n);
    stmx.d.resize(4 * n);
    stmx.build(0, 0, n, h);
    d.d.resize(4 * n);
    d.build(0, 0, n, h);
    for (int i = 0; i < n; i++) {
        lr.insert({i, i});
        l[i] = h[i];
        r[i] = h[i];
    }
    for (int i = 0; i < n - 1; i++) {
        int k;
        cin >> k;
        k--;
        update(k);
    }
}
